#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum AppearanceSetting {
    #[serde(rename = "SYSTEM")]
    System,
    #[serde(rename = "LIGHT")]
    Light,
    #[serde(rename = "DARK")]
    Dark,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl AppearanceSetting {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            AppearanceSetting::System => "SYSTEM",
            AppearanceSetting::Light => "LIGHT",
            AppearanceSetting::Dark => "DARK",
            AppearanceSetting::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for AppearanceSetting {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for AppearanceSetting {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for AppearanceSetting {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(
        v: &str,
    ) -> Result<AppearanceSetting, conjure_object::plain::ParseEnumError> {
        match v {
            "SYSTEM" => Ok(AppearanceSetting::System),
            "LIGHT" => Ok(AppearanceSetting::Light),
            "DARK" => Ok(AppearanceSetting::Dark),
            v => v.parse().map(|v| AppearanceSetting::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for AppearanceSetting {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<AppearanceSetting, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the AppearanceSetting enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
